SystemOrganization addCategory: #'STON-Core'!

!String methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:27'!
stonContainSubObjects 
	^ false! !

!String methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 1/14/2012 16:22'!
stonOn: stonWriter
	stonWriter writeString: self! !

!Character class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 15:17'!
fromSton: stonReader
	^ stonReader parseListSingleton first! !

!Character methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 20:02'!
stonOn: stonWriter
	stonWriter writeObject: self listSingleton: self asString! !

!Date class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 15:17'!
fromSton: stonReader
	^ self readFrom: stonReader parseListSingleton readStream! !

!Date methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:26'!
stonContainSubObjects 
	^ false! !

!Date methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 20:03'!
stonOn: stonWriter
	"Use an ISO style YYYYMMDD representation"
	
	stonWriter writeObject: self listSingleton: self yyyymmdd! !

!Number methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:26'!
stonContainSubObjects 
	^ false! !

!Number methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 1/14/2012 17:26'!
stonOn: stonWriter
	stonWriter writeFloat: self asFloat! !

!ByteArray class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 15:16'!
fromSton: stonReader
	^ self readHexFrom: stonReader parseListSingleton! !

!ByteArray methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:25'!
stonContainSubObjects 
	^ false! !

!ByteArray methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 20:02'!
stonOn: stonWriter
	"Use a hex representation"
	
	stonWriter writeObject: self listSingleton: self hex! !

!Dictionary class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 14:59'!
fromSton: stonReader
	"Instances of STON mapClass will be read directly and won't arrive here.
	Other (sub)classes will use this method."
	
	| dictionary |
	dictionary := self new.
	stonReader parseMapDo: [ :key :value |
		dictionary at: key put: value ].
	^ dictionary! !

!Dictionary methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 14:58'!
stonOn: stonWriter
	"Instances of STON mapClass will be encoded directly, without a class tag.
	Other (sub)classes will be encoded with a class tag and will use a map representation. "
	
	self class == STON mapClass
		ifTrue: [ 
			stonWriter writeMap: self ]
		ifFalse: [ 
			stonWriter 
				writeObject: self 
				do: [ stonWriter encodeMap: self ] ]! !

!Class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 20:06'!
stonName
	"Override to encode my instances using a different class name."
	
	^ self name! !

!SmallDictionary class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 9/17/2013 19:50'!
fromSton: stonReader
	"My instances are stored as maps."
	
	| dictionary |
	dictionary := self new.
	stonReader parseMapDo: [ :key :value |
		dictionary at: key put: value ].
	^ dictionary! !

!SmallDictionary methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 9/17/2013 20:13'!
stonOn: stonWriter
	"I store my instances as maps"
	
	stonWriter 
		writeObject: self 
		do: [ stonWriter encodeMap: self ]! !

!UndefinedObject methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:27'!
stonContainSubObjects 
	^ false! !

!UndefinedObject methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 1/14/2012 15:54'!
stonOn: stonWriter
	stonWriter writeNull! !

!Point methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 14:30'!
fromSton: stonReader
	stonReader parseListDo: [ :each :index |
		index = 1 ifTrue: [ x := each ].
		index = 2 ifTrue: [ y := each ] ]! !

!Point methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 1/24/2012 10:02'!
stonOn: stonWriter
	stonWriter writeObject: self streamShortList: [ :array |
		array add: x; add: y ]! !

!TimeStamp class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 13:56'!
fromSton: stonReader
	"We use a representation from DateAndTime"
	
	^ (super fromSton: stonReader) asTimeStamp! !

!DateAndTime class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 19:50'!
fromSton: stonReader
	^ DateAndTime readFrom: stonReader parseListSingleton readStream! !

!DateAndTime methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:25'!
stonContainSubObjects 
	^ false! !

!DateAndTime methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 20:03'!
stonOn: stonWriter
	"Use an ISO representation with all details"
	
	stonWriter writeObject: self listSingleton: 
		(String streamContents: [ :stream |
			self printOn: stream withLeadingSpace: false ])! !

!Symbol methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 1/14/2012 16:22'!
stonOn: stonWriter
	stonWriter writeSymbol: self! !

!Integer methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 1/14/2012 15:47'!
stonOn: stonWriter
	stonWriter writeInteger: self! !

!SequenceableCollection class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 15:07'!
fromSton: stonReader
	^ self streamContents: [ :stream |
		stonReader parseListDo: [ :each |
			stream nextPut: each ] ]! !

!SequenceableCollection methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/8/2012 19:22'!
stonOn: stonWriter
	self class == STON listClass
		ifTrue: [ stonWriter writeList: self ]
		ifFalse: [ super stonOn: stonWriter ]! !

!Time class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 15:17'!
fromSton: stonReader
	^ self readFrom: stonReader parseListSingleton readStream! !

!Time methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:26'!
stonContainSubObjects 
	^ false! !

!Time methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 20:03'!
stonOn: stonWriter
	"Use an ISO style HH:MM:SS representation"
	 
	stonWriter writeObject: self listSingleton: 
		(String streamContents: [ :stream |
			self print24: true on: stream ])! !

!Boolean methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:24'!
stonContainSubObjects 
	^ false! !

!Boolean methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 1/14/2012 15:53'!
stonOn: stonWriter
	stonWriter writeBoolean: self! !

!Object class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 19:58'!
fromSton: stonReader
	"Create a new instance and delegate decoding to instance side.
	Override only when new instance should be created directly (see implementors). "
	
	^ self new
		fromSton: stonReader;
		yourself! !

!Object methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 4/29/2012 12:23:33'!
fromSton: stonReader
	"Decode non-variable classes from a map of their instance variables and values.
	Override to customize and add a mathcing #toSton: (see implementors)."
	
	self class isVariable 
		ifTrue: [
			self subclassResponsibility ]
		ifFalse: [
			stonReader parseMapDo: [ :instVarName :value |
				self instVarNamed: instVarName put: value ] ]
! !

!Object methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 1/18/2012 20:16'!
isStonReference
	^ false! !

!Object methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:24'!
stonContainSubObjects
	"Return true if I contain subObjects that should be processed, false otherwise.
	Overwrite when necessary. See also #stonProcessSubObjects:"
	
	^ true! !

!Object methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/28/2012 14:27'!
stonOn: stonWriter
	"Encode non-variable classes with a map of their instance variable and values.
	Override to customize and add a matching #fromSton: (see implementors)."

	self class isVariable 
		ifTrue: [
			self subclassResponsibility ]
		ifFalse: [
			stonWriter writeObject: self ]
! !

!Object methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:22'!
stonProcessSubObjects: block
	"Execute block to (potentially) change each of my subObjects.
	In general, all instance and indexable variables are processed.
	Overwrite when necessary. Not used when #stonContainSubObjects returns false."
	
	1 to: self class instSize do: [ :each |
		self instVarAt: each put: (block value: (self instVarAt: each)) ].
	(self class isVariable and: [ self class isBytes not ])
		ifTrue: [
			1 to: self basicSize do: [ :each |
				self basicAt: each put: (block value: (self basicAt: each)) ] ]! !

!Object methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/13/2013 23:43'!
stonShouldWriteNilInstVars
	"Return true if my instance variables that are nil should be written out, 
	false otherwise. Overwrite when necessary. By default, return false."
	
	^ false! !

Object subclass: #STON
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STON commentStamp: 'SvenVanCaekenberghe 5/3/2012 19:20' prior: 0!
STON implements serialization and materialization using the Smalltalk Object Notation format.
 
S y n t a x

	value
	  primitive-value
	  object-value
	  reference
	  nil
	primitive-value
	  number
	  true
	  false
	  symbol
	  string
	object-value
	  object
	  map
	  list
	object
	  classname map
	  classname list
	reference
	  @ int-index-previous-object-value
	map
	  {}
	  { members }
	members
	  pair
	  pair , members
	pair
	  string : value
	  symbol : value
	  number : value
	list
	  []
	  [ elements ]
	elements
	  value 
	  value , elements
	string
	  ''
	  ' chars '
	chars
	  char
	  char chars
	char
	  any-printable-ASCII-character-
	    except-'-"-or-\
	  \'
	  \"
	  \\
	  \/
	  \b
	  \f
	  \n
	  \r
	  \t
	  \u four-hex-digits
	symbol
	  # chars-limited
	  # ' chars '
	chars-limited
	  char-limited
	  char-limited chars-limited
	char-limited
	  a-z A-Z 0-9 - _ . /
	classname
	  uppercase-alpha-char alphanumeric-char
	number
	  int
	  int frac
	  int exp
	  int frac exp
	int
	  digit
	  digit1-9 digits 
	  - digit
	  - digit1-9 digits
	frac
	  . digits
	exp
	  e digits
	digits
	  digit
	  digit digits
	e
	  e
	  e+
	  e-
	  E
	  E+
	  E-
!

!STON class methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 1/24/2012 09:39'!
fromStream: readStream
	^ (self reader on: readStream) next! !

!STON class methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 1/24/2012 09:40'!
fromString: string
	^ self fromStream: string readStream! !

!STON class methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 5/15/2012 09:32'!
jsonWriter
	^ STONWriter new
		  jsonMode: true;
		  yourself! !

!STON class methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/24/2012 09:36'!
listClass
	^ Array! !

!STON class methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/24/2012 09:36'!
mapClass
	^ Dictionary! !

!STON class methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 5/30/2012 22:06'!
put: object asJsonOnStream: stream
	(self jsonWriter on: stream) nextPut: object! !

!STON class methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 5/30/2012 22:07'!
put: object asJsonOnStreamPretty: stream
	(self jsonWriter on: stream)
		prettyPrint: true; 
		nextPut: object! !

!STON class methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 1/24/2012 09:49'!
put: object onStream: stream
	(self writer on: stream) nextPut: object! !

!STON class methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 2/12/2012 19:30'!
put: object onStreamPretty: stream
	(self writer on: stream)
		prettyPrint: true; 
		nextPut: object! !

!STON class methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/24/2012 09:37'!
reader
	^ STONReader new! !

!STON class methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 5/30/2012 22:07'!
toJsonString: object
	^ String streamContents: [ :stream |
		self put: object asJsonOnStream: stream ]! !

!STON class methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 5/30/2012 22:07'!
toJsonStringPretty: object
	^ String streamContents: [ :stream |
		self put: object asJsonOnStreamPretty: stream ]! !

!STON class methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 1/24/2012 09:49'!
toString: object
	^ String streamContents: [ :stream |
		self put: object onStream: stream ]! !

!STON class methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 2/12/2012 19:30'!
toStringPretty: object
	^ String streamContents: [ :stream |
		self put: object onStreamPretty: stream ]! !

!STON class methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/24/2012 09:37'!
writer
	^ STONWriter new! !

Object subclass: #STONReader
	instanceVariableNames: 'readStream objects classes unresolvedReferences stringStream allowComplexMapKeys stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STONReader commentStamp: 'SvenVanCaekenberghe 5/29/2012 21:15' prior: 0!
STONReader materializes objects using the Smalltalk Object Notation format.

This parser is backwards compatible with standard JSON.!

!STONReader class methodsFor: 'instance creation' stamp: 'SvenVanCaekenberghe 1/14/2012 20:25'!
on: readStream
	^ self new
		on: readStream;
		yourself! !

!STONReader methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 10/25/2012 15:24'!
allowComplexMapKeys: boolean
	allowComplexMapKeys := boolean! !

!STONReader methodsFor: 'testing' stamp: 'SvenVanCaekenberghe 5/7/2012 13:49'!
atEnd
	^ readStream atEnd! !

!STONReader methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 1/14/2012 20:26'!
close
	readStream ifNotNil: [
		readStream close.
		readStream := nil ]! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 2/6/2012 20:59'!
consumeWhitespace
	"Strip whitespaces from the input stream."

	[ readStream atEnd not and: [ readStream peek isSeparator ] ]
		whileTrue: [ readStream next ]! !

!STONReader methodsFor: 'error handling' stamp: 'SvenVanCaekenberghe 2/8/2012 09:23'!
error: aString
	^ STONReaderError signal: aString! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 5/7/2012 10:33'!
expectChar: character
	"Expect character and consume input and optional whitespace at the end,
	 throw an error otherwise."

	(self matchChar: character)
		ifFalse: [ self error: character asString, ' expected' ]! !

!STONReader methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 11/29/2012 14:47'!
initialize
	super initialize.
	objects := IdentityDictionary new.
	classes := IdentityDictionary new.
	allowComplexMapKeys := false.
	stack := Stack new.
	unresolvedReferences := 0! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 2/12/2012 19:27'!
isClassChar: char
	^ 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789' includes: char! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 2/12/2012 19:27'!
isClassStartChar: char
	^ 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' includes: char! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 2/12/2012 19:28'!
isSimpleSymbolChar: char
	^ 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_./' includes: char! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 2/11/2012 12:44'!
lookupClass: name
	Smalltalk globals 
		at: name 
		ifPresent: [ :class | ^ class ].
	^ classes 
		at: name 
		ifAbsentPut: [
			Object allSubclasses 
				detect: [ :class | class stonName == name ] 
				ifNone: [ self error: 'Cannot resolve class named ', name printString ] ]
	! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 12/3/2012 10:57'!
match: string do: block
	"Try to read and consume string and execute block if successful.
	Else do nothing (but do not back up)"

	(string allSatisfy: [ :each | readStream peekFor: each ])
		ifTrue: [ 
			self consumeWhitespace.
			block value ]! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 12/3/2012 10:54'!
matchChar: character
	"Tries to match character, consume input and 
	answer true if successful and consumes whitespace at the end."

	^ (readStream peekFor: character)
		ifTrue: [ 
			self consumeWhitespace.
			true ]
		ifFalse: [ false ]! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 1/18/2012 20:54'!
newReference
	| index reference |
	index := objects size + 1.
	reference := STONReference index: index.
	objects at: index put: reference.
	^ reference! !

!STONReader methodsFor: 'public' stamp: 'SvenVanCaekenberghe 4/27/2012 16:48'!
next
	| object |
	self consumeWhitespace.
	object := self parseValue.
	unresolvedReferences > 0
		ifTrue: [ self processSubObjectsOf: object ].
	^ object! !

!STONReader methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 1/14/2012 20:26'!
on: aReadStream
	readStream := aReadStream! !

!STONReader methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 11/29/2012 15:54'!
optimizeForLargeStructures
	self class environment
		at: #FLLargeIdentityDictionary
		ifPresent: [ :identityDictionaryClass | objects := identityDictionaryClass new ].
	self class environment 
		at: #FLSimpleStackstack 
		ifPresent: [ :stackClass | stack := stackClass new ]! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 1/15/2012 21:38'!
parseCharacter
	| char |
	(char := readStream next) = $\ 
		ifFalse: [ ^ char ].
	(#( $' $" $/ $\) includes: (char := readStream next))
		ifTrue: [ ^ char ].
	char = $b
		ifTrue: [ ^ Character backspace ].
	char = $f
		ifTrue: [ ^ Character newPage ].
	char = $n
		ifTrue: [ ^ Character lf ].
	char = $r
		ifTrue: [ ^ Character cr ].
	char = $t
		ifTrue: [ ^ Character tab ].
	char = $u
		ifTrue: [ ^ self parseCharacterHex ].
	self error: 'invalid escape character \' , (String with: char)! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 5/29/2012 21:12'!
parseCharacterHex
	| value |
	value := self parseCharacterHexDigit.
	3 timesRepeat: [ 
		value := (value << 4) + self parseCharacterHexDigit ].
	^ Character codePoint: value! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 1/15/2012 11:28'!
parseCharacterHexDigit
	| digit |
	readStream atEnd ifFalse: [ 
		digit := readStream next asInteger.
		(digit between: "$0" 48 and: "$9" 57)
			ifTrue: [ ^ digit - 48 ].
		(digit between: "$A" 65 and: "$F" 70)
			ifTrue: [ ^ digit - 55 ].
		(digit between: "$a" 97 and: "$f" 102)
			ifTrue: [ ^ digit - 87 ] ].
	self error: 'hex-digit expected'! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 5/29/2012 21:13'!
parseClass
	| className |
	className := self stringStreamContents: [ :stream |
		[ readStream atEnd not and: [ self isClassChar: readStream peek ] ] whileTrue: [ 
			stream nextPut: readStream next ] ].
	self consumeWhitespace.
	^ self lookupClass: className asSymbol
	! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 5/7/2012 13:16'!
parseConstantDo: block
	"Parse and consume either true|false|nil|null and execute block 
	or else do nothing (but do not back up).
	Hand written implementation to avoid the use of #position:"
	
	(readStream peek = $t)
		ifTrue: [
			^ self match: 'true' do: [ block value: true ] ].
	(readStream peek = $f)
		ifTrue: [
			^ self match: 'false' do: [ block value: false ] ].
	(readStream peek = $n)
		ifTrue: [
			readStream next.
			(readStream peek = $i)
				ifTrue: [
					self match: 'il' do: [ block value: nil ] ].
			(readStream peek = $u)
				ifTrue: [
					self match: 'ull' do: [ block value: nil ] ] ]		
! !

!STONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 2/12/2012 15:21'!
parseList
	| reference array |
	reference := self newReference.
	array := STON listClass streamContents: [ :stream |
		self parseListDo: [ :each | stream nextPut: each ] ].
	self setReference: reference to: array.
	^ array! !

!STONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 5/7/2012 10:34'!
parseListDo: block
	| index |
	self expectChar: $[.
	(self matchChar: $]) 
		ifTrue: [ ^ self ].
	index := 1.
	[ readStream atEnd ] whileFalse: [
		block cull: self parseValue cull: index.
		(self matchChar: $]) 
			ifTrue: [ ^ self ].
		index := index + 1.
		self expectChar: $, ].
	self error: 'end of list expected'! !

!STONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 2/12/2012 15:55'!
parseListSingleton
	| value |
	value := nil.
	self parseListDo: [ :each :index |
		index = 1 ifTrue: [ value := each ] ].
	^ value! !

!STONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 2/12/2012 15:22'!
parseMap
	| map |
	map := STON mapClass new.
	self storeReference: map.
	self parseMapDo: [ :key :value |
		map at: key put: value ].
	^ map! !

!STONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 10/25/2012 15:29'!
parseMapDo: block
	self expectChar: ${.
	(self matchChar: $})
		ifTrue: [ ^ self ].
	[ readStream atEnd ] whileFalse: [ | name value |
		name := self parseValue.
		(allowComplexMapKeys or: [ name isString or: [ name isNumber ] ])
			ifFalse: [ self error: 'unexpected property name type' ].
		self expectChar: $:.
		value := self parseValue.
		block value: name value: value.
		(self matchChar: $}) 
			ifTrue: [ ^ self ].
		self expectChar: $, ].
	self error: 'end of map expected'! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 12/3/2012 11:08'!
parseNumber
	| negated number |
	negated := readStream peekFor: $-.
	number := self parseNumberInteger.
	(readStream peekFor: $.)
		ifTrue: [ number := number + self parseNumberFraction ].
	((readStream peekFor: $e) or: [ readStream peekFor: $E ])
		ifTrue: [ number := number * self parseNumberExponent ].
	negated
		ifTrue: [ number := number negated ].
	self consumeWhitespace.
	^ number! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 12/3/2012 11:08'!
parseNumberExponent
	| number negated |
	number := 0.
	(negated := readStream peekFor: $-)
		ifFalse: [ readStream peekFor: $+ ].
	[ readStream atEnd not and: [ readStream peek isDigit ] ]
		whileTrue: [ number := 10 * number + readStream next digitValue ].
	negated
		ifTrue: [ number := number negated ].
	^ 10 raisedTo: number! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 1/15/2012 10:52'!
parseNumberFraction
	| number power |
	number := 0.
	power := 1.0.
	[ readStream atEnd not and: [ readStream peek isDigit ] ] whileTrue: [
		number := 10 * number + readStream next digitValue.
		power := power * 10.0 ].
	^ number / power! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 5/29/2012 21:13'!
parseNumberInteger
	| number |
	number := 0.
	[ readStream atEnd not and: [ readStream peek isDigit ] ] whileTrue: [ 
		number := 10 * number + readStream next digitValue ].
	^ number! !

!STONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 2/12/2012 13:45'!
parseObject
	| targetClass reference object |
	targetClass := self parseClass.
	reference := self newReference.
	object := targetClass fromSton: self.
	self setReference: reference to: object.
	^ object! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 11/29/2012 08:52'!
parseReference
	| index object |
	self expectChar: $@.
	index := self parseNumberInteger.
	self consumeWhitespace.
	unresolvedReferences := unresolvedReferences + 1.
	^ STONReference index: index! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 2/29/2012 21:50'!
parseString
	^ self parseStringInternal! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 5/29/2012 21:12'!
parseStringInternal
	| result delimiter |
	delimiter := readStream next.
	(delimiter = $' or: [ delimiter = $" ]) 
		ifFalse: [ self error: ''' or " expected' ].
	result := self stringStreamContents: [ :stream |
		[ readStream atEnd or: [ readStream peek = delimiter ] ] whileFalse: [ 
			stream nextPut: self parseCharacter ] ].
	self expectChar: delimiter.
	^ result! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 5/7/2012 10:42'!
parseSymbol
	| string |
	self expectChar: $#.
	readStream peek = $'
		ifTrue: [ ^ self parseStringInternal asSymbol ].
	string := self stringStreamContents: [ :stream |
		[ readStream atEnd not and: [ self isSimpleSymbolChar: readStream peek ] ] whileTrue: [
			stream nextPut: readStream next ] ].
	string isEmpty
		ifFalse: [ 
			self consumeWhitespace.
			^ string asSymbol ].
	self error: 'unexpected input'! !

!STONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 5/7/2012 13:16'!
parseValue
	| char |
	readStream atEnd ifFalse: [ 
		(self isClassStartChar: (char := readStream peek)) 
			ifTrue: [ ^ self parseObject ].
		char = ${
			ifTrue: [ ^ self parseMap ].
		char = $[
			ifTrue: [ ^ self parseList ].
		(char = $' or: [ char = $" ])
			ifTrue: [ ^ self parseString ].
		char = $#
			ifTrue: [ ^ self parseSymbol ].
		char = $@
			ifTrue: [ ^ self parseReference ].
		(char = $- or: [ char isDigit ])
			ifTrue: [ ^ self parseNumber ].
		self parseConstantDo: [ :value | ^ value ] ].
	self error: 'invalid input'! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 11/29/2012 16:29'!
processSubObjectsOf: object
	stack push: object.
	[ stack isEmpty ]
		whileFalse: [ 
			stack pop
				stonProcessSubObjects: [ :each | 
					each isStonReference
						ifTrue: [ self resolveReference: each ]
						ifFalse: [ 
							each stonContainSubObjects
								ifTrue: [ stack push: each ]
								ifFalse: [ each ] ] ] ]! !

!STONReader methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 10/25/2012 17:37'!
reset
	unresolvedReferences := 0.
	objects removeAll! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/27/2012 16:31'!
resolveReference: reference
	^ self resolveReferenceIndex: reference index! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 1/18/2012 21:03'!
resolveReferenceIndex: index
	^ objects at: index! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 1/18/2012 21:01'!
setReference: reference to: object
	objects at: reference index put: object! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 1/16/2012 11:10'!
storeReference: object
	| index |
	index := objects size + 1.
	objects at: index put: object.
	^ index! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 2/9/2012 17:23'!
stringStreamContents: block
	stringStream ifNil: [ 
		stringStream := (String new: 32) writeStream ].
	stringStream reset.
	block value: stringStream.
	^ stringStream contents! !

Object subclass: #STONReference
	instanceVariableNames: 'index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STONReference commentStamp: 'SvenVanCaekenberghe 1/22/2012 20:13' prior: 0!
STONReference holds a forward reference to another object during materialization.
!

!STONReference class methodsFor: 'instance creation' stamp: 'SvenVanCaekenberghe 1/18/2012 19:37'!
index: integer
	^ self new
		index: integer;
		yourself! !

!STONReference methodsFor: 'comparing' stamp: 'SvenVanCaekenberghe 1/18/2012 20:23'!
= anObject
	^ self class == anObject class and: [ self index = anObject index ]! !

!STONReference methodsFor: 'comparing' stamp: 'SvenVanCaekenberghe 1/18/2012 20:22'!
hash
	^ index hash! !

!STONReference methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/18/2012 19:35'!
index
	^ index! !

!STONReference methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/18/2012 19:35'!
index: integer
	index := integer! !

!STONReference methodsFor: 'testing' stamp: 'SvenVanCaekenberghe 1/18/2012 20:22'!
isStonReference
	^ true! !

!STONReference methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 11/28/2012 21:06'!
printOn: stream
	super printOn: stream.
	stream nextPut: $(; print: index; nextPut: $)! !

Object subclass: #STONStreamWriter
	instanceVariableNames: 'writer first'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STONStreamWriter commentStamp: '<historical>' prior: 0!
STONStreamWriter helps in streaming writing STON representations.
This is an abstract class.!

STONStreamWriter subclass: #STONListWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STONListWriter commentStamp: '<historical>' prior: 0!
STONArrayWriter helps in writing array based STON representations.
!

!STONListWriter methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/24/2012 10:03'!
add: anObject
	first ifTrue: [ first := false ] ifFalse: [ writer listElementSeparator ].
	writer nextPut: anObject! !

STONListWriter subclass: #STONShortListWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STONShortListWriter commentStamp: '<historical>' prior: 0!
STONShortArrayWriter helps in writing short array based STON representations.
!

!STONShortListWriter methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 2/12/2012 15:49'!
add: anObject
	first ifTrue: [ first := false ] ifFalse: [ writer shortListElementSeparator ].
	writer nextPut: anObject! !

STONStreamWriter subclass: #STONMapWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STONMapWriter commentStamp: '<historical>' prior: 0!
STONDictionaryWriter helps in writing dictionary based STON representations.!

!STONMapWriter methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/24/2012 10:03'!
at: key put: value
	first ifTrue: [ first := false ] ifFalse: [ writer mapElementSeparator ].
	writer encodeKey: key value: value! !

!STONStreamWriter class methodsFor: 'instance creation' stamp: 'SvenVanCaekenberghe 1/24/2012 09:29'!
on: stonWriter
	^ self new
		on: stonWriter;
		yourself! !

!STONStreamWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 1/24/2012 09:30'!
initialize
	super initialize.
	first := true! !

!STONStreamWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 1/24/2012 09:29'!
on: stonWriter
	writer := stonWriter! !

Object subclass: #STONWriter
	instanceVariableNames: 'writeStream prettyPrint newLine jsonMode referencePolicy level objects'
	classVariableNames: 'STONCharacters STONSimpleSymbolCharacters'
	poolDictionaries: ''
	category: 'STON-Core'!

!STONWriter commentStamp: 'SvenVanCaekenberghe 4/27/2012 14:08' prior: 0!
STONWriter serializes objects using the Smalltalk Object Notation format. 

Customization options are:

- prettyPrint <Boolean> default is false
	if true, produce pretty printed output
- jsonMode <Boolean> default is false
	if true, the follow changes occur
	- strings are delimited with double quotes
	- nil is encoded as null
	- symbols are treated as strings
	- only STON listClass and STON mapClass instances are allowed as composite objects
	it is wise to also use either #error or #ignore as referencePolicy to avoid references
- referencePolicy <#normal|#ignore|#error> default is #normal
	if #normal, track and count object references and use references to implement sharing and break cycles
	if #error, track object references and signal STONWriterError when a shared reference is encountered
	if #ignore, don't track object references which might loop forever on cycles
 !

!STONWriter class methodsFor: 'class initialization' stamp: 'SvenVanCaekenberghe 2/9/2012 16:43'!
initialize
	self initializeSTONCharacters.
	self initializeSTONSimpleSymbolCharacters! !

!STONWriter class methodsFor: 'class initialization' stamp: 'SvenVanCaekenberghe 1/14/2012 23:20'!
initializeSTONCharacters
	| escapes |
	STONCharacters := Array new: 127.
	32 to: 126 do: [ :each | 
		STONCharacters at: each + 1 put: #pass ].
	escapes := #( 8 '\b' 9 '\t' 10 '\n' 12 '\f' 13 '\r' 34 '\"' 39 '\''' 92 '\\' ).
	1 to: escapes size - 1 by: 2 do: [ :index | 
		STONCharacters 
			at: (escapes at: index) + 1
			put: (escapes at: index + 1) ]
	! !

!STONWriter class methodsFor: 'class initialization' stamp: 'SvenVanCaekenberghe 2/14/2012 17:50'!
initializeSTONSimpleSymbolCharacters
	"STONSimpleSymbolCharacters asArray collectWithIndex: [ :each :index |
		each isZero ifTrue: [ (index - 1) asCharacter ] ]."
		
	STONSimpleSymbolCharacters := ByteArray new: 256 withAll: 1.
	1 to: 256 do: [ :each | | char |
		char := (each - 1) asCharacter.
		(self isSimpleSymbolChar: char)
			ifTrue: [ 
				STONSimpleSymbolCharacters at: each put: 0 ] ]! !

!STONWriter class methodsFor: 'private' stamp: 'SvenVanCaekenberghe 2/14/2012 17:49'!
isSimpleSymbolChar: char
	^ 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_./' includes: char! !

!STONWriter class methodsFor: 'instance creation' stamp: 'SvenVanCaekenberghe 1/14/2012 15:48'!
on: writeStream
	^ self new
		on: writeStream;
		yourself! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 1/14/2012 15:37'!
close
	writeStream ifNotNil: [
		writeStream close.
		writeStream := nil ]! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/29/2012 12:23:33'!
encodeCharacter: char
	| code encoding |
	((code := char codePoint) < 127 and: [ (encoding := STONCharacters at: code + 1) notNil ])
		ifTrue: [ 
			encoding = #pass
				ifTrue: [ writeStream nextPut: char ]
				ifFalse: [ writeStream nextPutAll: encoding ] ]
		ifFalse: [ 
			writeStream nextPutAll: '\u'.
			code printOn: writeStream base: 16 nDigits: 4 ]
! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 1/23/2012 11:32'!
encodeKey: key value: value
	self nextPut: key.
	self prettyPrintSpace.
	writeStream nextPut: $:.
	self prettyPrintSpace.
	self nextPut: value! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 5/5/2012 16:56'!
encodeList: elements
	writeStream nextPut: $[.
	elements isEmpty
		ifTrue: [
			self prettyPrintSpace ]
		ifFalse: [
			self indentedDo: [
				self newlineIndent.
				elements 
					do: [ :each | self nextPut: each ]
					separatedBy: [ self listElementSeparator ] ].
			self newlineIndent ].
	writeStream nextPut: $]
! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 5/5/2012 16:56'!
encodeMap: pairs
	| first |
	first := true.
	writeStream nextPut: ${.
	pairs isEmpty
		ifTrue: [
			self prettyPrintSpace ]
		ifFalse: [
			self indentedDo: [
				self newlineIndent.
				pairs keysAndValuesDo: [ :key :value |
					first 
						ifTrue: [ first := false ] 
						ifFalse: [ self mapElementSeparator ].
					self encodeKey: key value: value ] ].
			self newlineIndent ].
	writeStream nextPut: $}! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/27/2012 13:49'!
encodeString: string
	writeStream nextPut: (jsonMode ifTrue: [ $" ] ifFalse: [ $' ]).
	string do: [ :each |
		self encodeCharacter: each ].
	writeStream nextPut: (jsonMode ifTrue: [ $" ] ifFalse: [ $' ]).! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 1/23/2012 11:12'!
indentedDo: block
	level := level + 1.
	block value.
	level := level - 1! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 3/7/2013 10:38'!
initialize
	super initialize.
	prettyPrint := false.
	newLine := String cr.
	level := 0.
	referencePolicy := #normal.
	jsonMode := false.
	objects := IdentityDictionary new! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/29/2012 12:23:33'!
isSimpleSymbol: symbol
	^ (symbol class 
		findFirstInString: symbol 
		inSet: STONSimpleSymbolCharacters 
		startingAt: 1) = 0
! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 4/27/2012 13:53'!
jsonMode: boolean
	jsonMode := boolean! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/29/2012 12:23:33'!
listElementSeparator
	writeStream nextPut: $,.
	self newlineIndent
! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/29/2012 12:23:33'!
mapElementSeparator
	writeStream nextPut: $,.
	self newlineIndent
! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 3/7/2013 10:46'!
newLine: string
	newLine := string! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 3/7/2013 10:39'!
newlineIndent
	prettyPrint ifTrue: [ 
		writeStream nextPutAll: newLine.
		level timesRepeat: [ writeStream tab ] ]! !

!STONWriter methodsFor: 'public' stamp: 'SvenVanCaekenberghe 1/14/2012 15:47'!
nextPut: anObject
	anObject stonOn: self! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 4/29/2012 12:23:33'!
on: aWriteStream
	writeStream := aWriteStream
! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 11/29/2012 15:54'!
optimizeForLargeStructures
	self class environment
		at: #FLLargeIdentityDictionary
		ifPresent: [ :identityDictionaryClass | objects := identityDictionaryClass new ].! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 1/14/2012 15:36'!
prettyPrint: boolean
	prettyPrint := boolean! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 1/23/2012 11:18'!
prettyPrintSpace
	prettyPrint ifTrue: [ writeStream space ]
! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 4/29/2012 12:23:33'!
referencePolicy: policy
	self assert: ( #(#normal #ignore #error) includes: policy ).
	referencePolicy := policy
! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 1/14/2012 15:37'!
reset
	objects removeAll! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/29/2012 12:23:33'!
shortListElementSeparator
	writeStream nextPut: $,.
	self prettyPrintSpace
! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/26/2012 17:18'!
with: object do: block
	| index |
	referencePolicy = #ignore 
		ifTrue: [ ^ block value ].
	(index := objects at: object ifAbsent: [ nil ]) notNil
		ifTrue: [
			referencePolicy = #error
				ifTrue: [ ^ STONWriterError signal: 'Shared reference detected' ].
			self writeReference: index ]
		ifFalse: [
			index := objects size + 1.
			objects at: object put: index.
			block value ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/14/2012 15:51'!
writeBoolean: boolean
	writeStream print: boolean! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/14/2012 16:05'!
writeFloat: float
	writeStream print: float! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/14/2012 15:48'!
writeInteger: integer
	writeStream print: integer! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/24/2012 10:00'!
writeList: collection
	self with: collection do: [ 
		self encodeList: collection ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/24/2012 10:01'!
writeMap: hashedCollection
	self with: hashedCollection do: [ 
		self encodeMap: hashedCollection ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 4/27/2012 13:50'!
writeNull
	jsonMode
		ifTrue: [ writeStream nextPutAll: 'null' ]
		ifFalse: [ writeStream print: nil ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 11/13/2013 23:46'!
writeObject: anObject
	| instanceVariableNames |
	(instanceVariableNames := anObject class allInstVarNames) isEmpty
		ifTrue: [ 
			self writeObject: anObject do: [ self encodeMap: #() ] ]
		ifFalse: [ 
			self writeObject: anObject streamMap: [ :dictionary | 
				instanceVariableNames do: [ :each | 
					(anObject instVarNamed: each)
						ifNotNil: [ :value | 
							dictionary at: each asSymbol put: value ]
						ifNil: [ 
							anObject stonShouldWriteNilInstVars 
								ifTrue: [ dictionary at: each asSymbol put: nil ] ] ] ] ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 4/27/2012 14:01'!
writeObject: anObject do: block
	(jsonMode and: [ anObject class ~= STON listClass and: [ anObject class ~= STON mapClass ] ])
		ifTrue: [ STONWriterError signal: 'Wrong object class for JSON mode' ].
	self with: anObject do: [
		writeStream nextPutAll: anObject class stonName.
		self prettyPrintSpace.
		block value ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 2/12/2012 20:02'!
writeObject: object listSingleton: element
	self writeObject: object do: [
		writeStream nextPut: $[.
		self 
			prettyPrintSpace;
			nextPut: element;
			prettyPrintSpace.
		writeStream nextPut: $] ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/24/2012 10:02'!
writeObject: object streamList: block
	self writeObject: object do: [ | listWriter |
		listWriter := STONListWriter on: self.
		writeStream nextPut: $[.
		self indentedDo: [
			self newlineIndent.
			block value: listWriter ].
		self newlineIndent.
		writeStream nextPut: $] ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/24/2012 10:02'!
writeObject: object streamMap: block
	self writeObject: object do: [ | mapWriter |
		mapWriter := STONMapWriter on: self.
		writeStream nextPut: ${.
		self indentedDo: [
			self newlineIndent.
			block value: mapWriter ].
		self newlineIndent.
		writeStream nextPut: $} ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/24/2012 10:02'!
writeObject: object streamShortList: block
	self writeObject: object do: [ | listWriter |
		listWriter := STONShortListWriter on: self.
		writeStream nextPut: $[.
		self indentedDo: [
			self prettyPrintSpace.
			block value: listWriter ].
		self prettyPrintSpace.
		writeStream nextPut: $] ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/14/2012 17:29'!
writeReference: index
	writeStream
		nextPut: $@;
		print: index! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 2/29/2012 21:49'!
writeString: string
	self encodeString: string! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 4/27/2012 13:52'!
writeSymbol: symbol
	jsonMode
		ifTrue: [
			self writeString: symbol ]
		ifFalse: [
			writeStream nextPut: $#.
			(self isSimpleSymbol: symbol)
				ifTrue: [
					writeStream nextPutAll: symbol ]
				ifFalse: [
					self encodeString: symbol ] ]! !

Error subclass: #STONReaderError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STONReaderError commentStamp: '<historical>' prior: 0!
STONReaderError is the error/exception signalled by STONReader when illegal/incorrect input is seen. 
!

Error subclass: #STONWriterError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STONWriterError commentStamp: 'SvenVanCaekenberghe 4/26/2012 17:17' prior: 0!
STONWriterError is the error/exception signalled by STONWriter when illegal/incorrect input is seen. !

!Collection class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 13:54'!
fromSton: stonReader
	| collection |
	collection := self new.
	stonReader parseListDo: [ :each |
		collection add: each ].
	^ collection! !

!Collection methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 4/29/2012 12:23:33'!
stonOn: stonWriter
	stonWriter writeObject: self do: [
		stonWriter encodeList: self ]
! !
STONWriter initialize!
